package auth

import (
	"encoding/base64"
	"fmt"

	"github.com/pivotal-cf/on-demand-service-broker/boshclient"
)

type basicAuthHeaderBuilder struct {
	username, password string
}

func (hb basicAuthHeaderBuilder) Build() (string, error) {
	return fmt.Sprintf("Basic %s", base64.StdEncoding.EncodeToString([]byte(fmt.Sprintf("%s:%s", hb.username, hb.password)))), nil
}

func NewBasicAuthHeaderBuilder(username, password string) boshclient.AuthHeaderBuilder {
	return basicAuthHeaderBuilder{
		username: username,
		password: password,
	}
}
