package boshclient

import (
	"fmt"
	"net/http"
)

func (c *Client) GetTasks(deploymentName string) ([]BoshTask, error) {
	var getTasksResponse []BoshTask

	err := c.getDataFromBoshCheckingForErrors(
		fmt.Sprintf("%s/tasks?deployment=%s", c.boshURL, deploymentName),
		http.StatusOK,
		&getTasksResponse,
	)

	if err != nil {
		// TODO this if block is a work around for a BOSH bug where we can't get the tasks for a deleted deployment - remove once fixed!
		e, ok := err.(unexpectedStatusError)
		if ok && e.actualStatus == http.StatusNotFound {
			return []BoshTask{{State: Done, Description: "", Result: ""}}, nil
		}
		return nil, err
	}

	return getTasksResponse, nil
}
