package broker

import "fmt"

func (b *Broker) Instances() ([]string, error) {
	instances, err := b.instanceRepo.AllInstances()
	if err != nil {
		b.logger.Println(fmt.Errorf("error listing instances: %s", err))
		return nil, err
	}

	instanceIDs := []string{}
	for _, instance := range instances {
		instanceIDs = append(instanceIDs, instance.ID)
	}

	return instanceIDs, nil
}
