package broker_test

import (
	"errors"

	"github.com/pivotal-cf/on-demand-service-broker/broker"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

var _ = Describe("Instances", func() {
	Describe("listing all instances", func() {
		Context("of which there are three", func() {
			JustBeforeEach(func() {
				instances := []broker.Instance{{ID: "red"}, {ID: "green"}, {ID: "blue"}}
				instanceRepo.AllInstancesReturns(instances, nil)
			})

			It("returns a list of the instances' IDs", func() {
				Expect(b.Instances()).To(ConsistOf("red", "green", "blue"))
			})
		})

		Context("but failing to do so", func() {
			JustBeforeEach(func() {
				instanceRepo.AllInstancesReturns(nil, errors.New("fnuh"))
			})

			It("returns HTTP 500", func() {
				_, err := b.Instances()
				Expect(err).To(MatchError(ContainSubstring("fnuh")))
			})
		})
	})
})
