package broker

import "fmt"

func (b *Broker) redeploy(instance Instance, planID string, lastOperation OperationType, requestParams map[string]interface{}, previousPlanID *string) error {
	deploymentName := deploymentName(instance.ID)
	oldManifest, err := b.boshClient.GetManifestRaw(deploymentName)
	if err != nil {
		return fmt.Errorf("error getting old manifest: %s", err)
	}
	if oldManifest == nil {
		return DeploymentNotFoundError{fmt.Errorf("there is no old manifest, the instance must not exist")}
	}
	instance, _, err = b.deployer.Deploy(instance, planID, deploymentName, lastOperation, requestParams, oldManifest, previousPlanID)
	if err != nil {
		return err
	}

	return nil
}

const InstancePrefix = "service-instance_"

func deploymentName(instanceID string) string {
	return InstancePrefix + instanceID
}
