package broker

func (b *Broker) Upgrade(instanceID string) error {
	b.deploymentLock.Lock()
	defer b.deploymentLock.Unlock()

	instance, err := b.instanceRepo.FindByID(instanceID)
	if err != nil {
		return err
	}

	b.logger.Printf("upgrading instance %s", instance.ID)

	err = b.redeploy(instance, instance.PlanID, Upgrade, nil, &instance.PlanID)
	if err != nil {
		b.logger.Printf("error upgrading instance %s: %s", instanceID, err)
	}
	return err
}
